// **************************************************************************************
// el Comandante                                                    guerilla.bplaced.net
// --------------------------------------------------------------------------------------
// Information:
// I2C Scanner - Output to the TFT and to the serial monitor.
// I2C address list fetched from Adafruit Industries, created by lady ada.
// https://learn.adafruit.com/i2c-addresses/the-list
// --------------------------------------------------------------------------------------
// Used Libraries:
// TFT_eSPI --> https://github.com/Bodmer/TFT_eSPI
// **************************************************************************************

#include <Wire.h>
#include <TFT_eSPI.h>                                     // TFT_espi library
TFT_eSPI tft        = TFT_eSPI(); 

// ######################################################################################
// Change values in this area to match your envoirement and desires
// --------------------------------------------------------------------------------------
// Modify values, i.e. WT32-SC01 (SDA 18, SCL 19), TTGO T Display (SDA 21, SCL 22)
#define   SDA 18
#define   SCL 19
// Delay in ms for messages
uint16_t  messageDelay = 4000;
// ######################################################################################

TwoWire I2C = TwoWire(0);

// Vars
uint8_t  d[128] = {0};
uint8_t  e;
uint8_t  i;
uint8_t  n;
uint8_t  s;
char     I2CAddresses[128][394] =
{
  "Reserved - General Call Address",
  "Reserved for CBUS Compatibility",
  "Reserved for I2C-compatible Bus Variants",
  "Reserved for Future Use",
  "Reserved for Hs-mode Controller",
  "Reserved for Hs-mode Controller",
  "Reserved for Hs-mode Controller",
  "Reserved for Hs-mode Controller",
  "Unknown",
  "Unknown",
  "Unknown",
  "LC709203F Fuel Gauge and Battery Monitor",
  "MLX90393 3-Axis Magnetometer",
  "MLX90393 3-Axis Magnetometer",
  "MAG3110 3-Axis Magnetometer\nMLX90393 3-Axis Magnetometer",
  "MLX90393 3-Axis Magnetometer",
  "VEML6075 UV sensor\nVEML7700 Ambient Light sensor",
  "Si4713 FM Transmitter with RDS",
  "PMSA0031 Gas Sensor",
  "VCNL40x0 proximity sensor",
  "Unknown",
  "Unknown",
  "Unknown",
  "Unknown",
  "MCP9808 temp sensor\nMPRLS Pressure sensor LIS331\n3-axis accelerometer\nLIS3DH 3-axis accelerometer",
  "MCP9808 temp sensor\nLIS331 3-axis accelerometer\nLIS3DH 3-axis accelerometer\nLSM303 Accelerometer & Magnetometer",
  "MCP9808 temp sensor",
  "MCP9808 temp sensor",
  "LIS3MDL Magetometer\nMCP9808 temp sensor\nMMA845x 3-axis Accelerometer\nFXOS8700 Accelerometer/Magnetometer\nMMA7455L",
  "ADXL343 3-axis accelerometer\nADXL345 3-axis accelerometer\nFXOS8700 Accelerometer/Magnetometer\nLSM9DS0 9-axis IMU\nMCP9808 temp sensor\nMMA7455L\nMMA845x 3-axis Accelerometer",
  "FXOS8700 Accelerometer/Magnetometer\nHMC5883 Magnetometer\nLIS2MDL Magnetometer\nLIS3MDL Magnetometer\nLSM303 Accelerometer & Magnetometer\nLSM9DS0 9-axis IMU\nMCP9808 temp sensor",
  "MCP9808 temp sensor\nFXOS8700 Accelerometer/Magnetometer",
  "FXAS21002 Gyroscope\nChirp! Water sensor\nMCP23008 I2C GPIO expander\nMCP23017 I2C GPIO expander",
  "FXAS21002 Gyroscope\nMCP23008 I2C GPIO expander\nMCP23017 I2C GPIO expander",
  "MCP23008 I2C GPIO expander\nMCP23017 I2C GPIO expander",
  "BH1750 Light Sensor\nMCP23008 I2C GPIO expander\nMCP23017 I2C GPIO expander",
  "MCP23008 I2C GPIO expander\nMCP23017 I2C GPIO expander",
  "MCP23008 I2C GPIO expander\nMCP23017 I2C GPIO expander",
  "MCP23008 I2C GPIO expander\nMCP23017 I2C GPIO expander\nMSA301 Triple Axis Accelerometer",
  "MCP23008 I2C GPIO expander\nMCP23017 I2C GPIO expander",
  "BNO055 IMU\nCAP1188 8-channel Capacitive Touch\nDS1841 I2C Digital Logarithmic Potentiometer\nDS3502 I2C Digital 10K Potentiometer\nPCT2075 Temperature Sensor\nTSL2591 light sensor",
  "BNO055 IMU\nDS1841 I2C Digital Logarithmic Potentiometer\nDS3502 I2C Digital 10K Potentiometer\nPCT2075 Temperature Sensor\nTCS34725 color sensor\nTSL2561 light sensor\nTSL2591 light sensor\nVL53L0x ToF distanceVL6180X ToF sensor\nCAP1188 8-channel Capacitive Touch",
  "CAP1188 8-channel Capacitive Touch\nDS1841 I2C Digital Logarithmic Potentiometer\nDS3502 I2C Digital 10K Potentiometer\nPCT2075 Temperature Sensor",
  "CAP1188 8-channel Capacitive Touch\nDS1841 I2C Digital Logarithmic Potentiometer\nDS3502 I2C Digital 10K Potentiometer\nPCT2075 Temperature Sensor",
  "CAP1188 8-channel Capacitive Touch\nPCT2075 Temperature Sensor",
  "CAP1188 8-channel Capacitive Touch\nPCT2075 Temperature Sensor",
  "PCT2075 Temperature Sensor",
  "Unknown",
  "Unknown",
  "Unknown",
  "Unknown",
  "MLX90640 IR Thermal Camera",
  "Unknown",
  "Unknown",
  "Adafruit I2C QT Rotary Encoder with NeoPixel",
  "Unknown",
  "AHT20 Temp sensor\nVEML6070 UV Index\nFT6x06 Capacitive Touch Driver",
  "AS7341 Color Sensor\nTSL2561 light sensor\nVEML6070 UV Index\nAPDS-9960 IR/Color/Proximity Sensor",
  "Unknown",
  "Unknown",
  "SSD1305 monochrome OLED\nSSD1306 monochrome OLED",
  "SSD1305 monochrome OLED\nSSD1306 monochrome OLED",
  "Unknown",
  "Unknown",
  "PCA9685\nSi7021 Humidity/Temp sensor\nHTU21D-F Humidity/Temp Sensor\nHTU31D Humidity/Temp Sensor\nHDC1008 Humidity/Temp sensor\nMS8607 Temp/Barometric/Humidity\nTMP007 IR Temperature sensor\nTMP006 IR Temperature sensor\nPCA9685 16-channel PWM driver default address\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor",
  "PCA9685\nHDC1008 Humidity/Temp sensor\nHTU31D Humidity/Temp Sensor\nTMP007 IR Temperature sensor\nTMP006 IR Temperature sensor\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nSTMPE610/STMPE811 Resistive Touch controller",
  "PCA9685\nHDC1008 Humidity/Temp sensor\nTMP007 IR Temperature sensor\nTMP006 IR Temperature sensor\nINA219 High-Side DC Current/Voltage sensor",
  "PCA9685\nHDC1008 Humidity/Temp sensor\nTMP007 IR Temperature sensor\nTMP006 IR Temperature sensor\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor",
  "PCA9685\nSHT40 Humidity/Temp sensor\nSHT31 Humidity/Temp sensor\nTMP007 IR Temperature sensor\nTMP006 IR Temperature sensor\nISL29125 Color Sensor\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nSTMPE610/STMPE811 Resistive Touch controller",
  "PCA9685\nSHT31 Humidity/Temp sensor\nTMP007 IR Temperature sensor\nTMP006 IR Temperature sensor\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor",
  "PCA9685\nTMP007 IR Temperature sensor\nTMP006 IR Temperature sensor\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor",
  "PCA9685\nTMP007 IR Temperature sensor\nTMP006 IR Temperature sensor\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor",
  "PCA9685\nADS1115 4-channel 16-bit ADC\nADT7410 Temp sensor\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nPCF8591 Quad 8-bit ADC + 8-bit DAC\nPCT2075 Temperature Sensor\nPN532 NFC/RFID reader\nTMP102 Temperature sensor\nTMP117 Temperature sensor",
  "PCA9685\nADS1115 4-channel 16-bit ADC\nADT7410 Temp sensor\nAS7262 Light/Color sensor\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nPCF8591 Quad 8-bit ADC + 8-bit DAC\nPCT2075 Temperature Sensor\nTSL2561 light sensor\nTMP102 Temperature sensor\nTMP117 Temperature sensor",
  "PCA9685\nADS1115 4-channel 16-bit ADC\nADT7410 Temp sensor\nBNO085 9-DoF IMU\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nPCF8591 Quad 8-bit ADC + 8-bit DAC\nPCT2075 Temperature Sensor\nTMP102 Temperature sensor\nTMP117 Temperature sensor",
  "PCA9685\nADS1115 4-channel 16-bit ADC\nADT7410 Temp sensor\nBNO085 9-DoF IMU\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nPCF8591 Quad 8-bit ADC + 8-bit DAC\nPCT2075 Temperature Sensor\nTMP102 Temperature sensor\nTMP117 Temperature sensor",
  "PCA9685\nEMC2101 Fan Controller\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nPCF8591 Quad 8-bit ADC + 8-bit DAC\nPCT2075 Temperature Sensor",
  "PCA9685\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nPCF8591 Quad 8-bit ADC + 8-bit DAC\nPCT2075 Temperature Sensor",
  "PCA9685\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nPCF8591 Quad 8-bit ADC + 8-bit DAC\nPCT2075 Temperature Sensor",
  "PCA9685\nINA219 High-Side DC Current/Voltage sensor\nINA260 Precision DC Current/Power Sensor\nPCF8591 Quad 8-bit ADC + 8-bit DAC\nPCT2075 Temperature Sensor",
  "PCA9685\n24LCxx series EEPROMs\nMB85RC I2C FRAM",
  "PCA9685\n24LCxx series EEPROMs\nMB85RC I2C FRAM",
  "PCA9685\n24LCxx series EEPROMs\nMB85RC I2C FRAM\nNintendo Nunchuck controller",
  "PCA9685\n24LCxx series EEPROMs\nADXL343 3-axis accelerometer\nADXL345 3-axis accelerometer\nLTR390 UV sensor\nMB85RC I2C FRAM",
  "PCA9685\n24LCxx series EEPROMs\nMB85RC I2C FRAM",
  "PCA9685\n24LCxx series EEPROMs\nMB85RC I2C FRAM",
  "PCA9685\n24LCxx series EEPROMs\nMB85RC I2C FRAM",
  "PCA9685\n24LCxx series EEPROMs\nMB85RC I2C FRAM\nMAX3010x Pulse & Oximetry sensor",
  "PCA9685\nAW9523 GPIO Expander and LED Driver\nTPA2016 I2C-controlled Amplifier\nSGP30 Gas Sensor",
  "PCA9685\nAW9523 GPIO Expander and LED Driver\nSGP40 Gas Sensor",
  "PCA9685\nAW9523 GPIO Expander and LED Driver\nMPR121 12-point capacitive touch sensor\nCCS811 VOC sensor\nMLX9061x IR temperature sensor\nDRV2605 Haptic Motor Driver",
  "PCA9685\nAW9523 GPIO Expander and LED Driver\nMPR121 12-point capacitive touch sensor\nCCS811 VOC sensor",
  "PCA9685\nAM2315 Humidity/Temp sensor\nAM2320 Humidity/Temp snesor\nBH1750 Light Sensor\nLPS22 Pressure Sensor\nLPS25 Pressure Sensor\nLPS33HW Ported Pressure Sensor\nLPS35HW Pressure Sensor\nMPR121 12-point capacitive touch sensor",
  "PCA9685\nLPS22 Pressure Sensor\nLPS25 Pressure Sensor\nLPS33HW Ported Pressure Sensor\nLPS35HW Pressure Sensor\nMPR121 12-point capacitive touch sensor",
  "PCA9685\nTLV493D triple-axis Magnetometer",
  "PCA9685\nHTS221 Humidity/Temp Sensor",
  "PCA9685\nATECC608 Cryptographic Co-Processor\nMCP4728 Quad DAC\nMCP9600 Temp Sensor\nMPL115A2 Barometric Pressure\nMPL3115A2 Barometric Pressure\nSi5351A Clock Generator\nSi1145 Light/IR Sensor\nMCP4725A0 12-bit DAC\nTEA5767 Radio receiver\nVCNL4040 Proximity and Ambient Light sensor",
  "PCA9685\nMCP4725A0 12-bit DAC\nMCP9600 Temp Sensor\nSi5351A Clock Generator\nSCD30 Humidity/Temp/Gas sensor",
  "PCA9685\nMCP4725A1 12-bit DAC\nMCP9600 Temp Sensor",
  "PCA9685\nMCP4725A1 12-bit DAC\nMCP9600 Temp Sensor\nSi4713 FM Transmitter with RDS",
  "PCA9685\nMCP4725A2 12-bit DAC\nMCP9600 Temp Sensor",
  "PCA9685\nMCP4725A2 12-bit DAC\nMCP9600 Temp Sensor",
  "PCA9685\nMCP4725A3 12-bit DAC\nMCP9600 Temp Sensor",
  "PCA9685\nMCP4725A3 12-bit DAC\nMCP9600 Temp Sensor",
  "PCA9685\nAMG8833 IR Thermal Camera Breakout\nDS1307 RTC\nDS3231 RTC\nICM-20649 Accel+Gyro\nITG3200 Gyro\nMPU-9250 9-DoF IMU\nMPU-60X0 Accel+Gyro\nPCF8523 RTC",
  "PCA9685\nAMG8833 IR Thermal Camera Breakout\nICM-20649 Accel+Gyro\nMPU-9250\nMPU-60X0 Accel+Gyro\nITG3200 Gyro",
  "PCA9685\nICM330DHC 6-axis IMU\nL3GD20H gyroscope\nLSM6DS33 6-axis IMU\nLSM6DSOX 6-axis IMU\nLSM9DS0 9-axis IMU",
  "PCA9685\nICM330DHC 6-axis IMU\nL3GD20H gyroscope\nLSM6DS33 6-axis IMU\nLSM6DSOX 6-axis IMU\nLSM9DS0 9-axis IMU",
  "PCA9685\n",
  "PCA9685\n",
  "PCA9685\n",
  "PCA9685\n",
  "PCA9685\nHT16K33 LED Matrix Driver\nPCT2075 Temperature Sensor\nTCA9548 1-to-8 I2C Multiplexer\nSHTC3 Temp and Humidity Sensor",
  "PCA9685\nHT16K33 LED Matrix Driver\nPCT2075 Temperature Sensor\nTCA9548 1-to-8 I2C Multiplexer",
  "PCA9685\nHT16K33 LED Matrix Driver\nPCT2075 Temperature Sensor\nTCA9548 1-to-8 I2C Multiplexer",
  "PCA9685\nHT16K33 LED Matrix Driver\nPCT2075 Temperature Sensor\nTCA9548 1-to-8 I2C Multiplexer",
  "PCA9685\nHT16K33 LED Matrix Driver\nIS31FL3731 144-LED CharliePlex driver\nPCT2075 Temperature Sensor\nTCA9548 1-to-8 I2C Multiplexer",
  "PCA9685\nHT16K33 LED Matrix Driver\nIS31FL3731 144-LED CharliePlex driver\nPCT2075 Temperature Sensor\nTCA9548 1-to-8 I2C Multiplexer",
  "PCA9685\nBME280 Temp/Barometric/Humidity\nBME680 Temp/Barometric/Humidity/Gas\nBMP280 Temp/Barometric\nBMP388 Temp/Barometric\nBMP390 Temp/Barometric\nDPS310 Barometric Sensor\nHT16K33 LED Matrix Driver\nIS31FL3731 144-LED CharliePlex driver\nMS5607/MS5611 Barometric Pressure\nMS8607 Temp/Barometric/Humidity\nPCT2075 Temperature Sensor\nTCA9548 1-to-8 I2C Multiplexer",
  "PCA9685\nBMA180 Accelerometer\nBME280 Temp/Barometric/Humidity\nBME680 Temp/Barometric/Humidity/Gas\nBMP180 Temp/Barometric\nBMP085 Temp/Barometric\nBMP280 Temp/Barometric\nBMP388 Temp/Barometric\nBMP390 Temp/Barometric\nDPS310 Barometric Sensor\nHT16K33 LED Matrix Driver\nIS31FL3731 144-LED CharliePlex driver\nMS5607/MS5611 Barometric Pressure\nPCT2075 Temperature Sensor\nTCA9548 1-to-8 I2C Multiplexer",
  "PCA9685\nReserved for 10-bit I2C Addressing",
  "PCA9685\nReserved for 10-bit I2C Addressing",
  "PCA9685\nReserved for 10-bit I2C Addressing",
  "PCA9685\nReserved for 10-bit I2C Addressing",
  "PCA9685\nReserved for Future Purposes",
  "PCA9685\nReserved for Future Purposes",
  "PCA9685\nReserved for Future Purposes",
  "PCA9685\nReserved for Future Purposes",
};


void setup()
{
  Serial.begin(115200);                                   // serial monitor
  I2C.begin(SDA, SCL, 400000);                            // I2C
  tft.init();                                             // TFT_eSPI
  digitalWrite(TFT_BL, 0);                                // switch backlight off
  tft.setRotation(0);                                     // set the desired rotation
  tft.setTextDatum(TL_DATUM);
  if (tft.width() >= 320 || tft.height() >= 320)          // big screen (i.e. WR32-SWC01 - 480 x 320)
  {s = 1;}
  else if (tft.width() < 320 || tft.height() < 320)       // small screen (i.e. LILYGO TTGO-T-Display - 240 x 135)
  {s = 0;}
  digitalWrite(TFT_BL, 1);                                // switch backlight on
}


void loop()
{  
  scan();                                                 // start scan
  delay(messageDelay);
  details();                                              // show details
}


void scan()
{
  screenScan();
  tft.setTextColor(0xFC00, 0x0000);
  Serial.println("Scanning I2C Bus 1");
  tft.println("Scanning I2C Bus 1");
  tft.setCursor(0, tft.getCursorY() + 2);
  n = 0;
  for(i = 0; i < 128; i++)
  {
    I2C.beginTransmission(i);
    e = I2C.endTransmission(true);
    if(e == 0)
    {
      tft.setTextColor(0x07FF, 0x0000);
      if(i < 16)
      {
        Serial.print('0');
        tft.print('0');
      }
      Serial.print(i, HEX);
      tft.print(i, HEX);
      d[n] = i;
      if ((i & 0x07) == 0x07)
      {
        Serial.println();
        tft.setCursor(0, tft.getCursorY() + tft.fontHeight() + 2);
      }
      else
      {
        Serial.print(" ");
        tft.setCursor(tft.getCursorX() + 5, tft.getCursorY());
      }
      n++;
    }
  }
  Serial.println("");
  Serial.print(n);
  Serial.println(" I2C Devices");
  Serial.println("");
  tft.setTextColor(0xFC00, 0x0000);
  tft.println("");
  tft.print(n);
  tft.println(" I2C Devices");
}

void details()
{
  if (n != 0)
  {
    for (i = 0; i < n; i++)
    {
      screenDetails();
      tft.setTextColor(0x07FF, 0x0000);
      e = d[i];
      Serial.print("0x");
      tft.print("0x");
      if(e < 16)
      {
        Serial.print('0');
        tft.print('0');
      }
      Serial.print(e, HEX);
      Serial.println(" - Known Devices:");
      Serial.println(I2CAddresses[e]);
      Serial.println("");
      tft.print(e, HEX);
      tft.println(" - Known Devices:");
      tft.setCursor(0, tft.getCursorY() + 2);
      tft.setTextColor(0xFFFE, 0x0000);
      tft.println(I2CAddresses[e]);
      tft.setCursor(0, tft.getCursorY() + 2);
      delay(messageDelay);
    }
  }
}

void screenScan()
{
  tft.fillScreen(0x0000);
  if (s == 1)
  {
    tft.setFreeFont(&FreeMono9pt7b);
    tft.setCursor(0, 16);
  }
  else
  {
    tft.setTextFont(0);
    tft.setCursor(0, 8);
  }
}

void screenDetails()
{
  tft.fillScreen(0x0000);
  if (s == 1)
  {
    tft.setFreeFont(&FreeSans9pt7b);
    tft.setCursor(0, 16);
  }
  else
  {
    tft.setTextFont(0);
    tft.setCursor(0, 8);
  }
}
